#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    [Description("Enter the description of your new custom indicator here")]
    public class PriceChange : Indicator
    {
        #region Variables
        // Wizard generated variables
        // User defined variables (add any user defined variables below)
        #endregion

        protected override void Initialize()
        {
            Add(new Plot(Color.FromKnownColor(KnownColor.Blue), PlotStyle.Line, "Change"));
            Overlay				= false;
        }

        protected override void OnBarUpdate()
        {
            Change.Set((Close[0]-Open[0])/Open[0]);
			
			if (Change[0]<0)
				PlotColors[0][0] = Color.Red;
			else
				PlotColors[0][0] = Color.Green;
        }

        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Change
        {
            get { return Values[0]; }
        }

        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private PriceChange[] cachePriceChange = null;

        private static PriceChange checkPriceChange = new PriceChange();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public PriceChange PriceChange()
        {
            return PriceChange(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public PriceChange PriceChange(Data.IDataSeries input)
        {
            if (cachePriceChange != null)
                for (int idx = 0; idx < cachePriceChange.Length; idx++)
                    if (cachePriceChange[idx].EqualsInput(input))
                        return cachePriceChange[idx];

            lock (checkPriceChange)
            {
                if (cachePriceChange != null)
                    for (int idx = 0; idx < cachePriceChange.Length; idx++)
                        if (cachePriceChange[idx].EqualsInput(input))
                            return cachePriceChange[idx];

                PriceChange indicator = new PriceChange();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                PriceChange[] tmp = new PriceChange[cachePriceChange == null ? 1 : cachePriceChange.Length + 1];
                if (cachePriceChange != null)
                    cachePriceChange.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachePriceChange = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PriceChange PriceChange()
        {
            return _indicator.PriceChange(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.PriceChange PriceChange(Data.IDataSeries input)
        {
            return _indicator.PriceChange(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PriceChange PriceChange()
        {
            return _indicator.PriceChange(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.PriceChange PriceChange(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.PriceChange(input);
        }
    }
}
#endregion
